* _generatePersonalityOptions(): added and use it
[util-vserver.git] / util-vserver / scripts / vserver.functions
index e35096e..9f92c7a 100644 (file)
@@ -28,6 +28,7 @@ declare -a CHCONTEXT_OPTS=()
 declare -a CAPCHROOT_OPTS=()
 declare -a INTERFACES=()
 
+declare -a INITCMD_RESCUE=( /bin/sleep 900 )
 declare -a INITCMD_START=()
 declare -a INITCMD_START_SYNC=()
 declare -a INITCMD_STOP=()
@@ -38,6 +39,7 @@ declare -a ENTER_SHELL=()
 
 declare -a OPTS_VCONTEXT_CREATE=()
 declare -a OPTS_VCONTEXT_MIGRATE=()
+declare -a OPTS_VCONTEXT_ENTER=()
 declare -a OPTS_VATTRIBUTE=( --flag fakeinit )
 declare -a OPTS_VSCHED=()
 
@@ -45,6 +47,7 @@ declare -a STOPCMD_PREPARE=()
 
 declare -a VSERVER_EXTRA_CMDS=()
 
+INIT_RESCUE=
 VSHELPER_SYNC_TIMEOUT=30
 USE_VNAMESPACE=
 INTERFACE_CMDS_IDX=0
@@ -63,7 +66,7 @@ SILENT_OPT=
 
 : ${VSERVER_NAME:=$(basename "$VSERVER_DIR")}
 
-if test -e "$VSERVER_DIR"/noisy -o "$OPTION_VERBOSE"; then
+if test -e "$VSERVER_DIR"/noisy -o -n "$OPTION_VERBOSE"; then
     SILENT_OPT=
 else
     SILENT_OPT='--silent'
@@ -75,7 +78,7 @@ function _generateChbindOptions
     local i
     local bcast=
 
-    test "$_HAVE_INTERFACE_OPTIONS" || _generateInterfaceOptions "$vdir"
+    test -n "$_HAVE_INTERFACE_OPTIONS" || _generateInterfaceOptions "$vdir"
 
     local f=$vdir/interfaces/bcast
     getFileValue bcast "$f"
@@ -100,6 +103,34 @@ function _generateNiceCommand
     NICE_CMD=( $_NICE -$nice )
 }
 
+
+function _generatePersonalityOptions
+{
+    local vdir="$1"
+    local f="$vdir"/personality
+    local type flags
+
+    test -s "$f" || return 0
+
+    {
+       local delim tmp
+
+       read type
+       while read tmp; do
+           case x$tmp in
+               (x\#*|x)        ;;
+               (*)             flags=$flags$delim$tmp
+                               delim=,
+                               ;;
+           esac
+       done
+    } <"$f"
+
+    OPTS_VCONTEXT_ENTER=( "${OPTS_VCONTEXT_ENTER[@]}"
+                          --personality-type "$type"
+                         ${flags:+--personality-flags "$flags"} )
+}
+
 function _generateCCapabilityOptions
 {
     local vdir=$1
@@ -164,9 +195,9 @@ function getEnterShell
 
     ENTER_SHELL=()
 
-    getFileValue ENTER_SHELL "$vdir"/shell "$CONFDIR"/.defaults/shell
+    getFileValue ENTER_SHELL "$vdir"/shell "$__CONFDIR"/.defaults/shell
     
-    test "$ENTER_SHELL" || {
+    test -n "$ENTER_SHELL" || {
        local i
        for i in "/bin/bash -login" "/bin/sh -l" /bin/csh; do
            set -- $i
@@ -186,9 +217,9 @@ function sendKillSequence
 
     while isCtxRunning "$ctx"; do
        test -z "$wait" || sleep "$wait"
-       
-       $_VKILL -c "$ctx" ${1:+-s "$1"} 2>/dev/null || :
-       test "$2" || break
+
+       killContext "$ctx" "$1"
+       test -n "$2" || break
        wait="$2"
        shift 2
     done
@@ -218,9 +249,16 @@ function _generateInitOptions
     getFileArray INITKILL_SEQ  "$cfgdir"/killseq || :
 
     case x"$INITSTYLE" in
+       (xrescue)
+           INITCMD_START=( "${INITCMD_RESCUE[@]}" )
+           INITCMD_STOP=( /sbin/killall5 )
+           _IS_FAKEINIT=1
+           _NEED_VSHELPER_SYNC=
+           ;;
+           
        (xsysv)
-           test "$RUNLEVEL_START" || RUNLEVEL_START=3
-           test "$RUNLEVEL_STOP"  || RUNLEVEL_STOP=6
+           test -n "$RUNLEVEL_START" || RUNLEVEL_START=3
+           test -n "$RUNLEVEL_STOP"  || RUNLEVEL_STOP=6
 
            for i in /etc/init.d/rc /etc/rc.d/rc; do
                test -x "$vdir/vdir/$i" || continue
@@ -245,8 +283,9 @@ function _generateInitOptions
            _IS_FAKEINIT=1
            INITCMD_START_SYNC=( "$_INITSYNC_MINIT_START" "$vdir" )
            _NEED_VSHELPER_SYNC=1
-           test -z "$RUNLEVEL_START" || INITCMD_START=( "${INITCMD_START[@]}" "$RUNLEVEL_START" )
-           test -z "$RUNLEVEL_STOP"  || INITCMD_STOP=(  "${INITCMD_STOP[@]}"  "$RUNLEVEL_STOP"  )
+           test -z "$RUNLEVEL_START"         || INITCMD_START=( "${INITCMD_START[@]}" "$RUNLEVEL_START" )
+           test -z "$RUNLEVEL_STOP"          || INITCMD_STOP=(  "${INITCMD_STOP[@]}"  "$RUNLEVEL_STOP"  )
+           ! isNumber "${RUNLEVEL_START:-3}" || INITCMD_PREPARE=( $_FAKE_RUNLEVEL "${RUNLEVEL_START:-3}" /var/run/utmp )
            ;;
 
        (xgentoo)
@@ -259,14 +298,15 @@ function _generateInitOptions
            exit 1;;
     esac
 
-    getFileArray INITCMD_START      "$cfgdir"/cmd.start      || :
-    getFileArray INITCMD_STOP       "$cfgdir"/cmd.stop       || :
-    getFileArray INITCMD_START_SYNC "$cfgdir"/cmd.start-sync || :
-    getFileArray INITCMD_STOP_SYNC  "$cfgdir"/cmd.stop-sync  || :
-    getFileArray INITCMD_PREPARE    "$cfgdir"/cmd.prepare    || :
-
+    if test x"$INITSTYLE" != xrescue; then
+       getFileArray INITCMD_START      "$cfgdir"/cmd.start      || :
+       getFileArray INITCMD_STOP       "$cfgdir"/cmd.stop       || :
+       getFileArray INITCMD_START_SYNC "$cfgdir"/cmd.start-sync || :
+       getFileArray INITCMD_STOP_SYNC  "$cfgdir"/cmd.stop-sync  || :
+       getFileArray INITCMD_PREPARE    "$cfgdir"/cmd.prepare    || :
+    fi
     
-    test "$OPTION_FORCE_SYNC" -o -e "$cfgdir"/sync || {
+    test -n "$OPTION_FORCE_SYNC" -o -e "$cfgdir"/sync || {
        INITCMD_START_SYNC=()
        INITCMD_STOP_SYNC=()
        _NEED_VSHELPER_SYNC=
@@ -321,17 +361,6 @@ function _generateChcontextOptions
        read domainname <"$vdir"/uts/domainname || read domainname <"$vdir"/domainname || :
     } 2>/dev/null
 
-    ## LEGACY ALERT
-    test \( ! -e "$vdir"/hostname   -o -e "$vdir"/uts/nodename   \) -a \
-        \( ! -e "$vdir"/domainname -o -e "$vdir"/uts/domainname \) || {
-       echo $"\
-The hostname is now configured in 'uts/nodename' but not in 'hostname' anymore;
-the old way is not supported when using 2.6 kernel patches so it is strongly
-recommended to move these files.
-
-The same applies to 'domainname' vs. 'uts/domainname'." >&2
-    }
-
     test -z "$S_CONTEXT" || ctx=$S_CONTEXT
 
     _generateCapabilityOptions "$vdir"
@@ -369,7 +398,7 @@ function _generateScheduleOptions
        } <"$f"
     } 2>/dev/null
 
-    test "$prio_bias" || {
+    test -n "$prio_bias" || {
        echo $"Bad content in '$f'; aborting..." >&2
        false
     }
@@ -381,31 +410,31 @@ function _generateScheduleOptions
 
 function _getInterfaceValue
 {
-    local val=$1
-    local dflt=$2
+    local _giv_val=$1
+    local _giv_dflt=$2
     shift 2
     
-    local i
-    local tmp
+    local _giv_i
+    local _giv_tmp
 
-    for i; do
-       read tmp  <"$i/$val" && break || :
+    for _giv_i; do
+       read _giv_tmp  <"$_giv_i/$_giv_val" && break || :
     done 2>/dev/null
 
-    : ${tmp:=$dflt}
-    eval $val=\$tmp
+    : ${_giv_tmp:=$_giv_dflt}
+    eval $_giv_val=\$_giv_tmp
 }
 
 ## Usage: _transformMask2Prefix <result-varname> <prefix> <mask>
 function _transformMask2Prefix
 {
-    local tmp=$2
+    local _tm2p_tmp=$2
     
-    test "$tmp" || {
-       $_MASK2PREFIX "$3" || tmp=$?
+    test -n "$_tm2p_tmp" || {
+       $_MASK2PREFIX "$3" || _tm2p_tmp=$?
     }
 
-    eval $1=\$tmp
+    eval $1=\$_tm2p_tmp
     return 0
 }
 
@@ -452,20 +481,21 @@ function _processSingleInterface
     _getInterfaceValue scope  '' "$iface" "$iface/.."
     _getInterfaceValue mac    '' "$iface"
 
-    test "$ip" || { echo $"Can not read ip for '$iface'"  >&2; return 1; }
+    test -n "$ip" || { echo $"Can not read ip for '$iface'"  >&2; return 1; }
+    test -n "$dev" -o -e "$iface"/nodev || {
+       echo $"No device specified for '$iface'" >&2
+       return 1;
+    }
 
-    test ! -e "$iface"/down    || up=
-    
-    while test "$dev"; do
+    test ! -e "$iface"/down || up=
+
+    while true; do
        _transformMask2Prefix prefix "$prefix" "$mask"
        INTERFACES=( "${INTERFACES[@]}" "$ip${prefix:+/$prefix}" )
 
-       test ! -e "$iface"/nodev || break
-       test ! -e "$iface"/only_ip || {
-           ## LEGACY ALERT
-           echo $"The 'only_ip' flag for interface '$iface' is deprecated; use 'nodev' instead of" >&2
-           break
-       }
+       test ! -e "$iface"/nodev   || break
+       ## LEGACY ALERT
+       test ! -e "$iface"/only_ip || break
 
        case "$dev" in
            (*.*)
@@ -474,7 +504,7 @@ function _processSingleInterface
                    return 1
                }
                test -f /proc/net/vlan || {
-                   _addInterfaceCmd VCONFIG "${dev/./ }"
+                   _addInterfaceCmd VCONFIG ${dev/./ }
                    _addInterfaceCmd IP_ADDR 127.0.0.1/8 broadcast 127.255.255.255 dev "$dev"
                    _addInterfaceCmd IP_LINK "$dev" $up
                }
@@ -485,11 +515,11 @@ function _processSingleInterface
            _addInterfaceCmd IP_ADDR  "$ip${prefix:+/$prefix}" broadcast ${bcast:-+} ${name:+label "$dev:$name"} dev "$dev"
            #_addInterfaceCmd IP_ROUTE "$ip${prefix:+/$prefix}" dev "$dev"
            _addInterfaceCmd IP_LINK  "$dev" $up
-       elif ! test "$ctx"; then
+       elif ! test -n "$ctx"; then
            echo $"Using 'dummy' (indirect) for interface '$dev' requires a fixed context number; dynamic ctx are not supported" >&2
            return 1
        else
-           test "$mac" || _generateMac mac "$(basename $iface)" "$ctx" || return 1
+           test -z "$mac" || _generateMac mac "$(basename $iface)" "$ctx" || return 1
            _addInterfaceCmd MODPROBE dummy "$dev"
            _addInterfaceCmd IP_LINK  dev dummy0 address "$mac"
            _addInterfaceCmd NAMEIF   "$dev" "$mac"
@@ -523,7 +553,7 @@ function enableInterfaces
     local i=0
     declare -a var
 
-    lock "$LOCKDIR"/vserver.interfaces
+    lock "$__LOCKDIR"/vserver.interfaces
 
     while test $i -lt $INTERFACE_CMDS_IDX; do
        eval var='( "${INTERFACE_CMDS_'$i'[@]}" )'
@@ -556,12 +586,12 @@ function enableInterfaces
 
 function disableInterfaces
 {
-    test "$_HAVE_INTERFACE_OPTIONS" || _generateInterfaceOptions "$1"
+    test -n "$_HAVE_INTERFACE_OPTIONS" || _generateInterfaceOptions "$1"
 
     local i=$INTERFACE_CMDS_IDX
     declare -a var
 
-    lock "$LOCKDIR"/vserver.interfaces
+    lock "$__LOCKDIR"/vserver.interfaces
     
     while test $i -gt 0; do
        let --i || :
@@ -612,7 +642,7 @@ function prepareStop
 {
     pushd "$1/vdir" >/dev/null
     case "$INITSTYLE" in
-       sysv)
+       (sysv)
            export PREVLEVEL=$RUNLEVEL_START # required by Debian's initscripts
            ;;
     esac
@@ -623,14 +653,15 @@ function prepareStop
 
 function generateOptions
 {
-    _generateInterfaceOptions  "$1"
-    test "$_HAVE_CHBIND_OPTIONS" || _generateChbindOptions "$1" 
-    _generateNiceCommand       "$1"
-    _generateInitOptions       "$1"
-    _generateChcontextOptions  "$1"
-    _generateScheduleOptions   "$1"
-
-    if test "$_IS_FAKEINIT"; then
+    _generateInterfaceOptions   "$1"
+    test -n "$_HAVE_CHBIND_OPTIONS" || _generateChbindOptions "$1" 
+    _generateNiceCommand        "$1"
+    _generateInitOptions        "$1"
+    _generateChcontextOptions   "$1"
+    _generateScheduleOptions    "$1"
+    _generatePersonalityOptions "$1"
+
+    if test -n "$_IS_FAKEINIT"; then
        CHCONTEXT_INIT_OPTS=( --disconnect --flag fakeinit )
        OPTS_VCONTEXT_MIGRATE=( "${OPTS_VCONTEXT_MIGRATE[@]}" --initpid --disconnect )
     fi
@@ -643,7 +674,19 @@ function _mountVserverInternal
     shift
 
     pushd "$vdir" >/dev/null
-    "$@" $_SECURE_MOUNT -a --chroot --fstab "$fstab"
+    "$@" $_SECURE_MOUNT -a --chroot --fstab "$fstab" --rootfs no
+    popd >/dev/null
+}
+
+function mountRootFS
+{
+    local cfgdir=$1
+    local vdir=$1/vdir
+    local fstab="$cfgdir"/fstab
+
+    test -e "$fstab" || return 0
+    pushd "$vdir" >/dev/null
+    $_SECURE_MOUNT -a --chroot --fstab "$fstab" --rootfs only -n
     popd >/dev/null
 }
 
@@ -655,21 +698,23 @@ function mountVserver
     local mtab_src
 
     test -e "$cfgdir"/fstab -o \
-         -e "$cfgdir"/fstab.local || return 0
+         -e "$cfgdir"/fstab.local -o \
+        -e "$cfgdir"/fstab.remote || return 0
 
-    findObject -r mtab_src "$vdir"/apps/init/mtab "$CONFDIR"/.defaults/init/mtab "$PKGLIBDEFAULTDIR"/mtab /dev/null
+    findObject -r mtab_src "$cfgdir"/apps/init/mtab "$__CONFDIR"/.defaults/init/mtab "$__PKGLIBDEFAULTDIR"/mtab /dev/null
     
     pushd "$vdir" >/dev/null
     $_CHROOT_CAT /etc/mtab <"$mtab_src"
     popd >/dev/null
 
-    test "$_HAVE_CHBIND_OPTIONS" || _generateChbindOptions "$cfgdir"
+    test -n "$_HAVE_CHBIND_OPTIONS" || _generateChbindOptions "$cfgdir"
 
     test -z "$NAMESPACE_CLEANUP" || isAvoidNamespace "$cfgdir" || \
        $_VNAMESPACE --cleanup
 
-    _mountVserverInternal "$cfgdir"/fstab       $_CHBIND "${CHBIND_OPTS[@]}"
+    _mountVserverInternal "$cfgdir"/fstab
     _mountVserverInternal "$cfgdir"/fstab.local
+    _mountVserverInternal "$cfgdir"/fstab.remote $_CHBIND "${CHBIND_OPTS[@]}"
 
     isAvoidNamespace "$cfgdir" || \
        $_SECURE_MOUNT --rbind -n "$vdir" "/"
@@ -681,10 +726,10 @@ function _umountVserverInternal
     test -e "$fstab" || return 0
     shift
 
-    tac "$fstab" | {
+    $_TAC "$fstab" | {
        is_ok=1
        while read src dst tmp; do
-           test "$tmp" || continue
+           test -n "$tmp" || continue
            case x"$src" in
                (x\#*)  continue;;
            esac
@@ -692,7 +737,7 @@ function _umountVserverInternal
        
            "$@" $_EXEC_CD "$dst" $_UMOUNT -lfn . || is_ok=
        done
-       test "$is_ok"
+       test -n "$is_ok"
     }
 }
 
@@ -705,20 +750,23 @@ function umountVserver
     isAvoidNamespace "$cfgdir"    || return 0
     test -e "$cfgdir"/fstab -o \
          -e "$cfgdir"/fstab.local || return 0
-    test "$_HAVE_CHBIND_OPTIONS"  || _generateChbindOptions "$cfgdir"
+    test -n "$_HAVE_CHBIND_OPTIONS"  || _generateChbindOptions "$cfgdir"
     
     pushd "$vdir/" >/dev/null || return 1
        _umountVserverInternal  "$cfgdir"/fstab.local                              || is_ok=
        _umountVserverInternal  "$cfgdir"/fstab       $_CHBIND "${CHBIND_OPTS[@]}" || is_ok=
     popd >/dev/null           || return 1
 
-    test "$is_ok"
+    test -n "$is_ok"
 }
 
 ## Usage: waitForSync <vserver> <vshelper-fifo-varname>
 function initSync
 {
-    test -z "$_NEED_VSHELPER_SYNC" || vshelper.initSync "$1" "$2"
+    local _is_meth=sync
+    test -n "$_NEED_VSHELPER_SYNC" || _is_meth=async
+
+    vshelper.initSync "$1" "$2" "$_is_meth"
 }
 
 ## Usage: waitForSync <vserver> [<vshelper-fifo>]
@@ -727,7 +775,7 @@ function waitForSync
     local cfgdir=$1
     local fifo=$2
     
-    if test "$_NEED_VSHELPER_SYNC"; then
+    if test -n "$_NEED_VSHELPER_SYNC"; then
        $_VSHELPER_SYNC "$fifo" "$VSHELPER_SYNC_TIMEOUT" || \
            warning $"\
 A timeout or other error occured while waiting for the synchronization
@@ -758,18 +806,69 @@ function execScriptlets
     declare -r flavor=$3
     local base i
 
-    for base in "$vdir"/scripts "$CONFDIR"/.defaults/scripts; do
+    for base in "$vdir"/scripts "$__CONFDIR"/.defaults/scripts; do
        local   DONT_SKIP_DEFAULTS=
        local   already_handled=
        
        for i in "$base/$flavor" "$base/$flavor.d"/*; do
-           test -f "$i" -a -r "$i" || continue
+           isRegularFile "$i" || continue
+           test  -r "$i"      || continue
+
            already_handled=1
            local start=
            test -x "$i" || start=_sourceWrap
            $start "$i" "$flavor" "$name"
        done
 
-       test -z "$already_handled" -o "$DONT_SKIP_DEFAULTS" || break
+       test -z "$already_handled" -o -n "$DONT_SKIP_DEFAULTS" || break
     done
 }
+
+
+function sanityCheck
+{
+    declare -r cfgdir=$1
+
+    ! test -e "$cfgdir"/fstab.local ||
+       warning $"\
+WARNING: 'fstab' will *not* be executed in the network context of the
+  vserver anymore. Therefore, 'fstab.local' has the same functionality
+  and is obsoleted. When you need the old behaviour, put the mounts
+  into 'fstab.remote'"
+
+    ! test -e "$cfgdir"/hostname -a ! -L "$cfgdir"/hostname ||
+       warning $"\
+WARNING: The hostname is now configured in 'uts/nodename' but not in
+  'hostname'."
+
+    ! test -e "$cfgdir"/domainname -a ! -L "$cfgdir"/domainname ||
+       warning $"\
+WARNING: The domainname is now configured in 'uts/domainname' but not
+  in 'domainname'." >&2
+
+  
+    local i
+    for i in "$cfgdir"/interfaces/*/only_ip; do
+       if test -e "$i"; then
+           local iface
+           iface=${i##$cfgdir/interfaces/}
+           iface=${iface%%/only_ip}
+           warning $"\
+WARNING: The 'only_ip' flag for interface '$iface' is deprecated; use
+  'nodev' instead of"
+       fi
+    done
+
+    find "$cfgdir" -type f -exec "$_CHECK_UNIXFILE" '{}' ';'
+
+    vshelper.doSanityCheck
+
+    $_VSERVER_INFO - VERIFYCAP ||
+       panic $"capabilities are not enabled in kernel-setup"
+
+    $_VSERVER_INFO - VERIFYPROC ||
+       panic $"\
+/proc/uptime can not be accessed. Usually, this is caused by
+procfs-security. Please read the FAQ for more details
+http://www.linux-vserver.org/index.php?page=Linux-Vserver+FAQ"
+}